        FUNCTION IFIND(XDATA, NDATA, TEST)
C
C INTEGER FUNCTION TO FIND THE POSITION OF A VALUE "TEST"
C IN AN ARRAY OF MONOTONICALLY INCREASING VALUES "XDATA(NDATA)"
C
C IFIND RETURNED IS THE POSITION OF THE ELEMENT IN THE ARRAY IF
C IT WAS PLACED IN THE ARRAY
C E.G. IFIND = 0 IF LESS THAN ALL XDATA, = NDATA+1 IF GREATER
C
        INTEGER*4 IFIND
        REAL*4 XDATA(1)
C
        IF(TEST.LT.XDATA(1)) THEN
          IFIND = 1
          RETURN
        ELSE IF(TEST.GE.XDATA(NDATA)) THEN
          IFIND = NDATA + 1
          RETURN
        END IF
        IF (NDATA.GE.32) THEN
C
C BINARY CHOP METHOD
C
          IFIND = 1
          ISTEP = NDATA
10        ISTEP = MAX(1, ISTEP/2)
          DO WHILE(TEST.GE.XDATA(IFIND) .AND. IFIND.LE.NDATA)
            IFIND = IFIND + ISTEP
          END DO
          IF(ISTEP.GT.1) THEN
            IFIND = IFIND - ISTEP + ISTEP/2
            GOTO 10
          END IF
        ELSE
C
C STRAIGHT-FORWARD METHOD
C
          DO IFIND = 2, NDATA
            IF(TEST.LT.XDATA(IFIND)) RETURN
          END DO
        END IF
        RETURN
        END
